/* cmd /V:ON
	for %X in (x64 x86) do @(^
		set g=$g(%X^)
		SetEnv.Cmd /Vista /Release /%X
		rc              /DUNICODE /D_UNICODE "$g.rc"
		cl /LD /O1 /GS- /DUNICODE /D_UNICODE /Fo"!g!.obj" /Fa"!g!.asm" /Fm"!g!.map" /Fe"!g!.dll" "$f" "$g.def" /link "$g.res" /NODEFAULTLIB /ENTRY:DllMain /MACHINE:%X user32.lib kernel32.lib
		del "$g.res" "!g!.obj" "!g!.asm" "!g!.map" "!g!.exp" "!g!.lib"^
	)
*/
#include "targetver.h"
#define  STRICT
#define  NOMINMAX
#define  WIN32_LEAN_AND_MEAN
#include <windows.h>

#include <algorithm>
#include <functional>
#include <iterator>
#include <utility>

#include "plugin.h"
#include "MeryRelay2.h"

#define IDS_MENU_LABEL     1
#define IDS_MENU_STATUS    2
#define IDS_MP_GET_NAME    MP_GET_NAME
#define IDS_MP_GET_VERSION MP_GET_VERSION

/*
	Relay  Mery ̃^u֘AÂpCvnhi[z
	ŏTCYB0 AWȏ̃P[X Mery ̎ʂ
	TCYKvȂ炢\ȃTCYŒ߂ĂB
*/
const size_t MINIMUM_RELAYHANDLE_ARRAYSIZE = 30;

/*
	VvċCȂ MeryRelay::Array ̕⏕֐B
	ŏTCY(MinSize)ێKȃTCY헪񋟂B
*/
template<size_t MinSize, typename T> static inline
size_t DesiredSizeTeller(MeryRelay::Array<T>& array, T* filledEnd)
{
/*
	Ɗgkʂ̐HႢ́AEŃTCY
	JԂȂ߂̃}[WB
	g(k) Size  3/2{(1/2{)ɂȂƂA
	󂫂2/3ȏȂkA0ȂgƂB
	g̃}[W: g܂ Size/3. k܂ Size/3.
	k̃}[W: g܂ Size/3. k܂ Size/3.
*/
	return
		array.End() == filledEnd ? // g
			array.Size() + std::max<size_t>(array.Size() / 2, 1): // Œ 1 ̊g啝ۏ؂B
		std::distance(array.Begin(), filledEnd) <= array.Size() / 3 ? // k
			std::max(array.Size() / 2, MinSize):
		// ̂܂
			array.Size();
}

static struct Global {
	HINSTANCE hDll;
	MeryRelay nggmnt;
	MeryRelay::Array<std::pair<LRESULT, HANDLE> >
	          doc2pipe;
	template<typename T> static size_t
	          DesiredSize(MeryRelay::Array<T>& array, T* filledEnd);

	Global(HINSTANCE hDll)
	: hDll(hDll)
	, nggmnt(L"MeryRelay2")
	, doc2pipe(MINIMUM_RELAYHANDLE_ARRAYSIZE)
	{
		g = this;
	}
} *g;

template<typename T> inline
size_t
Global::
DesiredSize(MeryRelay::Array<T>& array, T* filledEnd)
{
	return DesiredSizeTeller<MINIMUM_RELAYHANDLE_ARRAYSIZE>(array, filledEnd);
}

BOOL WINAPI DllMain(HINSTANCE hDll, DWORD dwReason, LPVOID)
{
	static Global g_(hDll); // /NODEFAULTLIB ̂߂Ɏ̂֐ɒuāAfXgN^ɗ炸 Dispose ĂłB
	if (dwReason == DLL_PROCESS_DETACH) {
		g_.doc2pipe.Dispose();
	}
	return TRUE;
}

// -----------------------------------------------------------------------------
// OnCommand
// vOCsɌĂяo܂
// p[^
//   hwnd: EBhẼnh

EXTERN_C void WINAPI OnCommand(HWND)
{
}

// -----------------------------------------------------------------------------
// QueryStatus
//   vOCs\A܂̓`FbNꂽԂ𒲂ׂ܂
// p[^
//   hwnd:      EBhẼnh
//   pbChecked: `FbN̏
// ߂l
//   s\łTrueԂ܂

EXTERN_C BOOL WINAPI QueryStatus(HWND, LPBOOL pbChecked)
{
	*pbChecked = TRUE;
	return FALSE;
}

// -----------------------------------------------------------------------------
// GetMenuTextID
//   j[ɕ\eLXg̃\[Xʎq擾܂
// ߂l
//   \[Xʎq

EXTERN_C UINT WINAPI GetMenuTextID()
{
	return IDS_MENU_LABEL;
}

// -----------------------------------------------------------------------------
// GetStatusMessageID
//   c[`bvɕ\eLXg̃\[Xʎq擾܂
// ߂l
//   \[Xʎq

EXTERN_C UINT WINAPI GetStatusMessageID()
{
	return IDS_MENU_STATUS;
}

// -----------------------------------------------------------------------------
// GetIconID
//   c[o[ɕ\ACR̃\[Xʎq擾܂
// ߂l
//   \[Xʎq

EXTERN_C UINT WINAPI GetIconID()
{
	return 0;
}

// -----------------------------------------------------------------------------
// OnEvents
//   CxgɌĂяo܂
// p[^
//   hwnd:   EBhẼnh
//   nEvent: Cxg̎
//   lParam: bZ[WL̒ǉ
// l
//   EVENT_CREATE:             GfB^N
//   EVENT_CLOSE:              GfB^I
//   EVENT_CREATE_FRAME:       t[쐬ꂽ
//   EVENT_CLOSE_FRAME:        t[jꂽ
//   EVENT_SET_FOCUS:          tH[JX擾
//   EVENT_KILL_FOCUS:         tH[JX
//   EVENT_FILE_OPENED:        t@CJ
//   EVENT_FILE_SAVED:         t@Cۑ
//   EVENT_MODIFIED:           XV̏ԂύXꂽ
//   EVENT_CARET_MOVED:        J[\ړ
//   EVENT_SCROLL:             XN[ꂽ
//   EVENT_SEL_CHANGED:        I͈͂ύXꂽ
//   EVENT_CHANGED:            eLXgύXꂽ
//   EVENT_CHAR:               ͂ꂽ
//   EVENT_MODE_CHANGED:       ҏW[hύXꂽ
//   EVENT_DOC_SEL_CHANGED:    ANeBuȕύXꂽ
//   EVENT_DOC_CLOSE:          
//   EVENT_TAB_MOVED:          ^uړꂽ
//   EVENT_CUSTOM_BAR_CLOSING: JX^o[悤Ƃ
//   EVENT_CUSTOM_BAR_CLOSED:  JX^o[
//   EVENT_TOOL_BAR_CLOSED:    c[o[
//   EVENT_TOOL_BAR_SHOW:      c[o[\ꂽ
//   EVENT_IDLE:               ACh

EXTERN_C void WINAPI OnEvents(HWND hwnd, UINT nEvent, LPARAM lParam)
{
	// ^
	typedef std::pair<LRESULT, HANDLE>*      Iterator;
	typedef std::reverse_iterator<Iterator> RIterator;
	struct docIs : std::unary_function<std::pair<LRESULT, HANDLE>, bool> {
		LRESULT doc;
		docIs(LRESULT doc): doc(doc) {}
		result_type operator()(const argument_type& p) const { return doc == p.first; }
	};

	switch (nEvent)
	{
	case EVENT_DOC_SEL_CHANGED: // t@CJƂAJƂA^u؂ւƂB
	{
		MeryRelay::Handle h = g->nggmnt.Accept();
		if (! h.Valid()) {
			break; // UBƂŋB
		}

		LRESULT doc = Editor_Info(hwnd, MI_GET_ACTIVE_DOC, 0);
		if (g->doc2pipe.End() != std::find_if(g->doc2pipe.Begin(), g->doc2pipe.End(), docIs(doc))) {
			// ^u؂ւAJĂt@CēxJƂă^uANeBuɂȂB
			h.Close(); // QԖڂ Relay vZX͑₩ɏI(҂Ił͂)B Close ĂԕKv́A͂ȂB
			break;
		}

		wchar_t szPath[MAX_PATH]; szPath[0] = L'\0';
		Editor_Info(hwnd, MI_GET_FILE_NAME, (LPARAM)szPath);
		if (! szPath[0]) {
			h.Close(); // Ȃ̂ Relay ҂IB Close ĂԕKv́A͂ȂB
			break;
		}

		Iterator it = std::find_if(g->doc2pipe.Begin(), g->doc2pipe.End(), docIs(0)); // l 0 ̃hLgnh𖳌lƂĈĂ邪ǂ낤AMery H ƃhLgnh̖{̌^킩ȂBLRESULT  WPARAM ̌^ł傤H
		if (it == g->doc2pipe.End()) { // 󂫂ȂB
			// gčēx󂫂TB
			g->doc2pipe.Resize(g->DesiredSize(g->doc2pipe, it));
			it = std::find_if(g->doc2pipe.Begin(), g->doc2pipe.End(), docIs(0));
		}
		if (it == g->doc2pipe.End()) { // ͂󂫂ȂBTCYɎs悤B
			break;
		}

		// ^u܂ Relay ҂B
		*it = std::make_pair(doc, h.Release());
		break;
	}
	case EVENT_DOC_CLOSE:
	{
		Iterator it = std::find_if(g->doc2pipe.Begin(), g->doc2pipe.End(), docIs((LRESULT)lParam));
		if (it == g->doc2pipe.End()) {
			break;
		}
		CloseHandle(it->second); // ҂Ă Relay IB
	/*
		ȍ~͔z(g->doc2pipe)̐B

		1. ̗vf(itTail)O(it)ɋl߂āA̗vfɂB
		2. KvȂk߂B
	*/
		RIterator itTail = std::find_if(RIterator(g->doc2pipe.End()), RIterator(it+1), std::not1(docIs(0))); // ȂꍇƂ͂Ȃ킿 it == itTail łꍇBłȂB
		std::iter_swap(it, itTail);
		*itTail = std::make_pair(0, INVALID_HANDLE_VALUE);
		g->doc2pipe.Resize(g->DesiredSize(g->doc2pipe, &*itTail)); // o[XCe[^ł itTail  &* 邱ƂŁAitTail wĂvfwʂ̃Ce[^(ƂẴ|C^)ɓBuĝŌ̗vf̎vu󂫗vf̎n܂vŵƂ DesiredSize ֓nĂB
		break;
	}
	}
}

// -----------------------------------------------------------------------------
// PluginProc
//   vOCɑ郁bZ[W܂
// p[^
//   hwnd:   EBhẼnh
//   nMsg:   bZ[W
//   wParam: bZ[WL̒ǉ
//   lParam: bZ[WL̒ǉ
// ߂l
//   bZ[WɂقȂ܂

EXTERN_C LRESULT WINAPI PluginProc(HWND, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
	switch(nMsg)
	{
	case MP_GET_NAME:
	case MP_GET_VERSION:
		if (! lParam) {
			break;
		}
		return LoadStringW(g->hDll, nMsg, reinterpret_cast<LPWSTR>(lParam), static_cast<int>(wParam));
	}
	return	0;
}
